



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>OC - 正则表达式 - RegexKitLite</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">OC - 正则表达式 - RegexKitLite</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 01:34:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>正则表达式使用步骤:</p>
<p>1. 创建正则表达式对象, 设置约束条件;</p>
<div>
<pre class="prettyprint linenums"> NSString *pattern = @"\\d{1,3}";<br />
 NSRegularExpression *regex = [[NSRegularExpression alloc] initWithPattern:pattern options: error:nil];</pre>
</div>
<p>2. 测试字符串</p>
<div>
<pre class="prettyprint linenums"> // 2. 测试字符串<br />
 NSArray *results = [regex matchesInString:username options: range:NSMakeRange(, username.length)];<br />
 NSLog(@"%zd", results.count);</pre>
</div>
<p>3. 特殊符号详解:</p>
<ul><li>[0-9a-zA-Z]{2,6}?+*</li></ul>
<p>"[]"代表一个范围, 0-9之间或者a-z之间或者A-Z之间的字符;</p>
<p>"{}"代表连续字符的个数范围, 连续2 - 6个字母或者数字;</p>
<p>"\\d"相当于[0-9];</p>
<p>"?"代表 0个或者1个;</p>
<p>"+"代表 至少1个;</p>
<p>"*"代表任意多个;</p>
<ul><li><p>@"^\\d[0-9a-zA-Z]*\\d$" 相当于&nbsp;@"^\\d.*\\d$"</p></li></ul>
<p>^ : 以数字开头;</p>
<p>$ : 以数字结尾</p>
<p>. : 除换行符以外的任意字符;</p>
<p>4. 实际应用</p>
<div>
<pre class="prettyprint linenums">  NSString *text = @"[哈哈]// http://www.baidu.com 192.168.1.1; @浪小花 #解放军# WWW.baidu.com, [ni]百度";<br />
         /**<br />
          *  使用正则表达式的步骤<br />
          1. 创建一个正则表达式对象, 定义规则

          2. 利用正则表达式对象 来测试 相应的字符串<br />
          */

         // 1. 创建正则表达式<br />
         // 规则: [0-9], 查找0-9之间的数字; 相当于 \d (注意\转义字符)<br />
         // [a-z]{3,6}: 查找 连续3个到6个 的小写字母个数;<br />
         //<br />
         NSString *pattern = @"^\\d[0-9a-zA-Z]*\\d$";<br />
         // 1.1 QQ<br />
         pattern = @"^[1-9]\\d{4,10}$";

         // 1.2 phoneNum<br />
         pattern = @"^1[3578]\\d{9}$";

         // 1.3 ip<br />
         pattern = @"\\d+\\.\\d+\\.\\d+\\.\\d+";

         // 1.4 判断汉字[]<br />
         pattern = @"\\[[a-zA-Z\\u4e00-\\u9fa5]+\\]";

         // 1.5 @<br />
         pattern = @"@[0-9a-zA-Z\\u4e00-\\u9fa5]+";

         // 1.6 #<br />
         pattern = @"\\#[a-zA-Z\\u4e00-\\u9fa5]+\\#";

         // 1.7 链接 url<br />
         pattern = @"\\b(([\\w-]+://?|www[.])[^\\s()&lt;&gt;]+(?:\\([\\w\\d]+\\)|([^[:punct:]\\s]|/)))";

         pattern = @"\\[[a-zA-Z\\u4e00-\\u9fa5]+\\]|@[0-9a-zA-Z\\u4e00-\\u9fa5]+|\\#[a-zA-Z\\u4e00-\\u9fa5]+\\#|\\b(([\\w-]+://?|www[.])[^\\s()&lt;&gt;]+(?:\\([\\w\\d]+\\)|([^[:punct:]\\s]|/)))";

         NSRegularExpression *regex = [[NSRegularExpression alloc] initWithPattern:pattern options: error:nil];<br />
         // ? + *<br />
         // ?: 0个或者1个<br />
         // +: 至少1个<br />
         // *: 0个或者多个(任意)<br />
         // ^: 开头<br />
         // @"^\\d[0-9a-zA-Z]*\\d$" 以数字开头, 以数字结尾, 中间是任意多个数字或者字母;

         // 2. 测试字符串<br />
         NSArray *results = [regex matchesInString:text options: range:NSMakeRange(, text.length)];<br />
         for (NSTextCheckingResult *result in results) {<br />
             NSLog(@"%@ %@", NSStringFromRange(result.range), [text substringWithRange:result.range]);<br />
         }</pre>
</div>
<p>5. 常用的正则表达式</p>
<p><strong>"^\d+$"　　//非负整数（正整数 + 0）&nbsp;<br />"^[0-9]*[1-9][0-9]*$"　　//正整数&nbsp;<br />"^((-\d+)|(0+))$"　　//非正整数（负整数 + 0）&nbsp;<br />"^-[0-9]*[1-9][0-9]*$"　　//负整数&nbsp;<br />"^-?\d+$"　　　　//整数&nbsp;<br />"^\d+(\.\d+)?$"　　//非负浮点数（正浮点数 + 0）&nbsp;<br />"^(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*))$"　　//正浮点数&nbsp;<br />"^((-\d+(\.\d+)?)|(0+(\.0+)?))$"　　//非正浮点数（负浮点数 + 0）&nbsp;<br />"^(-(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*)))$"　　//负浮点数&nbsp;<br />"^(-?\d+)(\.\d+)?$"　　//浮点数&nbsp;<br />"^[A-Za-z]+$"　　//由26个英文字母组成的字符串&nbsp;<br />"^[A-Z]+$"　　//由26个英文字母的大写组成的字符串&nbsp;<br />"^[a-z]+$"　　//由26个英文字母的小写组成的字符串&nbsp;<br />"^[A-Za-z0-9]+$"　　//由数字和26个英文字母组成的字符串&nbsp;<br />"^\w+$"　　//由数字、26个英文字母或者下划线组成的字符串&nbsp;<br />"^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$"　　　　//email地址&nbsp;<br />"^[a-zA-z]+://(\w+(-\w+)*)(\.(\w+(-\w+)*))*(\?\S*)?$"　　//url<br />/^(d{2}|d{4})-((0([1-9]{1}))|(1[1|2]))-(([0-2]([1-9]{1}))|(3[0|1]))$/&nbsp;&nbsp; //&nbsp; 年-月-日<br />/^((0([1-9]{1}))|(1[1|2]))/(([0-2]([1-9]{1}))|(3[0|1]))/(d{2}|d{4})$/&nbsp;&nbsp; // 月/日/年<br />"^([w-.]+)@(([[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.)|(([w-]+.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(]?)$"&nbsp;&nbsp; //Emil<br />"(d+-)?(d{4}-?d{7}|d{3}-?d{8}|^d{7,8})(-d+)?"&nbsp;&nbsp;&nbsp;&nbsp; //电话号码<br />"^(d{1,2}|1dd|2[0-4]d|25[0-5]).(d{1,2}|1dd|2[0-4]d|25[0-5]).(d{1,2}|1dd|2[0-4]d|25[0-5]).(d{1,2}|1dd|2[0-4]d|25[0-5])$"&nbsp;&nbsp; //IP地址</strong></p>
<p><strong>^([0-9A-F]{2})(-[0-9A-F]{2}){5}$&nbsp;&nbsp; //MAC地址的正则表达式<br />^[-+]?\d+(\.\d+)?$&nbsp; //值类型正则表达式<br /></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93v3m08.html">2016&period;12&period;01 搭建dendroid备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql4mve9.html">jpa知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdjy038.html">html--整站制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm2m109.html">（转）Eclipse中junit框架的使用&mdash;&mdash;单元测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wlwxoq.html">spoj 2319 BIGSEQ - Sequence</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmgx6e9.html">Ruby中，&amp;amp&semi;&colon;（ampersand colon）的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memzv6q.html">Linux常用命令　　新手必看</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojonwlq.html">&lbrack;wiki&rsqb;CDN</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgvydd8.html">Lesson 1-2</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyzn4x9.html">svn 安装及更新web库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwd439.html">DirectX11 With Windows SDK--06 DirectXMath数学库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydyogq.html">Scrapy创建项目问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wx3zgq.html">android app demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvnnpk8.html">不能用notepad&plus;&plus;编辑器编写python</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll533eq.html">php接收base64图片并保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy22xn9.html">SVM较全面介绍，干货！（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j16pz09.html">洛谷P1886 滑动窗口（POJ&period;2823 Sliding Window）（区间最值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rgrz48.html">Java模式&mdash;简单工厂模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl5g6r9.html">SQL 存储过程中的IF&lowbar;BEGIN&lowbar;END作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql15xrk9.html">设置ip地址、掩码、网关、DNS</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xkeo09.html">最简便的MySql数据库备份方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vlz0n8.html">&lbrack;转&rsqb; React Native Navigator&hairsp;&mdash;&hairsp;Navigating Like A Pro in React Native</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvnxwzq.html">AIR lame参数配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/96og60y9.html">web项目设计与开发&mdash;&mdash;DBHelper2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1l0p69.html">ZooKeeper 分布式锁实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnvnjpq.html">zzzzw&lowbar;在线考试系统③完结篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydld6dq.html">linux的终端，网络虚拟终端，伪终端（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y2yxnq.html">Android开发5大布局方式详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z12o419.html">错误编码 &equals; 10022                                                    错误消息 &equals; SDK 组件 Qupaisdk 启动出错，错误消息为 &lbrack;Qupaisdk&rsqb;&comma; the android stack error message is Fail to start the plugin&comma; which is caused by No implem</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1ljw59.html">oracle11g不能导出空表</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
